#include "stdafx.h"
 
#include "cpss_dialog.h"
#include <stdio.h>
#include "ReifenDlg.h"
#include "TireCfg.h"
 
extern DWORD g_dwConfigable;

#define  HEIGHT_BUTTON_WIDTH 80
#define GAP_DEFAULT 24
#define  EDIT_BORDER 4 //5
#define EDIT_EXTRA_HEIGHT 4
#define DISPLAY_CELL Reifen_DISPLAY_CELL
 
#define PAGES 2
//void AlertBox(CString strTitle,int logo=0) ;
 typedef struct {
	UINT nID; //tire identify
	char  pstr[16]; // used when nID==-1
	POINT pt;	 
	COLORREF color;
	float temp,press;
	CMyBitmap placehold[4];
}  DISPLAY_CELL;

#if 0
TIRE_CFG gTireCfg[]={
	{0x0B,{3,8,10,1},{0,11,90,10}},{0x03,{3,8,10,1},{0,11,90,10}},
	{0x5B,3,8,10,1,0,11,90,10},{0x59,3,8,10,1,0,11,90,10},{0x55,3,8,10,1,0,11,90,10},{0x53,3,8,10,1,0,11,90,10},
	{0xBB,3,8,10,1,0,11,90,10},{0xB9,3,8,10,1,0,11,90,10},{0xB5,3,8,10,1,0,11,90,10},{0xB3,3,8,10,1,0,11,90,10},
 	{0xCB,3,8,10,1,0,11,90,10},{0xC9,3,8,10,1,0,11,90,10},{0xC5,3,8,10,1,0,11,90,10},{0xC3,3,8,10,1,0,11,90,10},
	{0xDB,3,8,10,1,0,11,90,10},{0xD9,3,8,10,1,0,11,90,10},{0xD5,3,8,10,1,0,11,90,10},{0xD3,3,8,10,1,0,11,90,10},
	{0,0,0,0,0}
};
#else
 
TIRE_CFG gTireCfg[]={
	{0x0B,3,8,10,1,0,11,90,10},{0x03,3,8,10,1,0,11,90,10},
	{0x5B,3,8,10,1,0,11,90,10},{0x59,3,8,10,1,0,11,90,10},{0x55,3,8,10,1,0,11,90,10},{0x53,3,8,10,1,0,11,90,10},
	{0xBB,3,8,10,1,0,11,90,10},{0xB9,3,8,10,1,0,11,90,10},{0xB5,3,8,10,1,0,11,90,10},{0xB3,3,8,10,1,0,11,90,10},
 	{0xCB,3,8,10,1,0,11,90,10},{0xC9,3,8,10,1,0,11,90,10},{0xC5,3,8,10,1,0,11,90,10},{0xC3,3,8,10,1,0,11,90,10},
	{0xDB,3,8,10,1,0,11,90,10},{0xD9,3,8,10,1,0,11,90,10},{0xD5,3,8,10,1,0,11,90,10},{0xD3,3,8,10,1,0,11,90,10},
	{0,0,0,0,0,0,0,0,0}
};
#endif
/******************************************
 DATAbyte 0: 1 Conti
DATAbyte 1: 4 -> Alarmvalues
DATAbyte 2: Tire Number
DATAbyte 3: Pressure Niederstwert
DATAbyte 4: Pressure Sollwert
DATAbyte 5: Pressure Toleranz
DATAbyte 6: Pressure Hochstwert
DATAbyte 7+8: Temperture Sollwert
DATAbyte 9+10 Temperature Toleranz
DATAbyte 11+12 Temperature Hochstwert
*************************************************/

static inline BYTE press_conv( float press )
{
    BYTE by = (press*100/4);
	return by;
}
static inline BYTE* temp_conv( float temp,BYTE* by)
{
    WORD dw = (temp+273)/0.03125;
	by[0]= (dw>>8)&0xff ; by[1] =dw&0xff;
	return by;
}	

static void send_tire_cfg()
{
int i=0;
#define datalen  11
BYTE data[datalen];
		while(gTireCfg[i].nID!=0){
			data[0]= gTireCfg[i].nID;
			data[1]= press_conv(gTireCfg[i].pressure[0]);
			data[2]= press_conv(gTireCfg[i].pressure[1]);
			data[3]= press_conv(gTireCfg[i].pressure[3]);
			data[4]= press_conv(gTireCfg[i].pressure[2]);
			temp_conv(gTireCfg[i].temp[1],data+5);
			temp_conv(gTireCfg[i].temp[3],data+7);
			temp_conv(gTireCfg[i].temp[1],data+9); 
			t55_send_alarm(data);
			i++;
		}
}

void save_tire_cfg()
{
	FILE *f = fopen(BORD_TIRE_CFG_NAME,"wt");
	if(f)
	{
		int i=0;
		while(gTireCfg[i].nID!=0){
			fprintf(f, "%d %.1f %.1f %.1f %.1f %.1f %.1f %.1f %.1f\n", gTireCfg[i].nID,
				gTireCfg[i].pressure[0],gTireCfg[i].pressure[1],gTireCfg[i].pressure[2],gTireCfg[i].pressure[3],
				gTireCfg[i].temp[0] ,gTireCfg[i].temp[1],gTireCfg[i].temp[2],gTireCfg[i].temp[3]);
			i++;
		}
		fclose(f);
		
	}
}


void load_tire_cfg()
{
	FILE* f = fopen(BORD_TIRE_CFG_NAME,"rt");
	if(f)
	{
		int i=0;
		int n = 0 ;
		TIRE_CFG cfg;
		
		do{
			memset(&cfg,0,sizeof(cfg));
			n = fscanf(f,"%d %f %f %f %f %f %f %f %f\n", &cfg.nID,
				&cfg.pressure[0],&cfg.pressure[1],&cfg.pressure[2],&cfg.pressure[3],
				&cfg.temp[0],&cfg.temp[1],&cfg.temp[2],&cfg.temp[3]);
			if(n>7)
			{
				TIRE_CFG* p = find_cfg(cfg.nID);
				if(p)
				{
					memcpy(p,&cfg,sizeof(cfg));
				}
			}
			i++;
		}while(n>=9);
		fclose(f);
	}
}
TIRE_CFG* find_cfg(int tire)
{
	int i=0;
	while(gTireCfg[i].nID!=0){
		if(gTireCfg[i].nID==tire) return &gTireCfg[i]; 
		i++;
	}
	return NULL;
}
#define Y_FIST 100
#define Y_MID1 170-1
#define Y_MID2 240-2
#define Y_LAST 310-3
//#define NULL_MYBITMAP 0,0,0,{NULL,NULL,NULL,NULL}
static DISPLAY_CELL  reifen_display_cell [ ]={
	{0x0B,{0},{110,Y_FIST} },{0x03,{0},{110,Y_LAST} },
	{0x5B,{0},{312,Y_FIST} },{0x59,{0},{312,Y_MID1} },{0x55,{0},{312,Y_MID2} },{0x53,{0},{312,Y_LAST} }
	
};
#if 0
static DISPLAY_CELL  reifen_display_cell2 [ ]={
	{0xBB,{0},{230,100}},{0xB9,{0},{230,Y_MID1}},{0xB5,{0},{230,Y_MID2}},{0xB3,{0},{230,312}},
	{0xCB,{0},{380,100}},{0xC9,{0},{380,Y_MID1}},{0xC5,{0},{380,Y_MID2}},{0xC3,{0},{380,312}},
	{0xDB,{0},{530,100}},{0xD9,{0},{530,Y_MID1}},{0xD5,{0},{530,Y_MID2}},{0xD3,{0},{530,312}},
};
#else
static DISPLAY_CELL  reifen_display_cell2 [ ]={
	{0xBB,{0},{230,Y_FIST} },{0xB9,{0},{230,Y_MID1}},{0xB5,{0},{230,Y_MID2}},{0xB3,{0},{230,Y_LAST} },
	{0xCB,{0},{380,Y_FIST} },{0xC9,{0},{380,Y_MID1}},{0xC5,{0},{380,Y_MID2}},{0xC3,{0},{380,Y_LAST} },
	{0xDB,{0},{530,Y_FIST} },{0xD9,{0},{530,Y_MID1}},{0xD5,{0},{530,Y_MID2}},{0xD3,{0},{530,Y_LAST} }
};

#endif
static const int reifenBmpId[]= {IDB_PLACE_141, IDB_PLACE_141_GREEN_OPAQUE,IDB_PLACE_141_RED_OPAQUE,IDB_PLACE_141_YELLOW_OPAQUE};
static inline int color2id(COLORREF clr)
{
	if(clr == RED_CLR) return 2;
	if(clr == GREEN_CLR) return 1;
	if(clr == TUHUANG_CLR) return 3;
	return 0;
}
#define m_btnlist m_Btns
#define m_btAct (&m_Btns[1])

#define m_btn2Func m_Btns[3]

static const BUTTON_ITEMEX Button1_EngInfo[] = 
{
	{ 480, Btn_CancelY,	250,42,IDS_CFG    ,IDBI_BUTTON_121x43  ,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_CFG} ,
	{ 620, 30,	250,42,ID_VU_HELP   ,IDBI_BUTTON_89X43 ,IDBI_BUTTON_89X43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,ID_VU_HELP} ,
 
};
static const BUTTON_ITEMEX Button_LR[] = {{ 308,30,	228,72,IDD_BUTTONS_RIGHT    ,IDD_BUTTONS_RIGHT      ,0}};

#define RL_BTN_FUNC(l,r)  	((COD2ButtonImpl*)&m_btn2Func)->ChangeFunc(l,r,m_nIDBACK, \
	(l!=r)?IDBI_LEFTRIGHT_LR:(l==IDD_BUTTONS_RIGHT?IDBI_LEFTRIGHT_RIGHT:IDBI_LEFTRIGHT_LEFT ),	 \
	(l!=r)?IDBI_LEFTRIGHT_LR_DN:(l==IDD_BUTTONS_RIGHT?IDBI_LEFTRIGHT_RIGHT_DN:IDBI_LEFTRIGHT_LEFT_DN ),	 \
								  Button_LR[0].rt.left,Button_LR[0].rt.top)


static const BUTTON_ITEM xxButtonInfo ={ Btn_CancelX, Btn_CancelY, Btn_CancelWidth,Btn_CancelHeight,ID_CANCEL,	IDBI_CANCEL,IDBI_CANCEL_DN};
 

 
static HWND g_hWnd=NULL;
DISPLAY_CELL* find_tire(int tire)
{
	DISPLAY_CELL * pCell=0;
	int i, count;
	 
	pCell = reifen_display_cell;
	count = sizeof(reifen_display_cell)/sizeof(DISPLAY_CELL);
	
	 
	for(i=0;i<count;i++)
	{
		if(pCell[i].nID==tire) return &pCell[i];
	}

	pCell = reifen_display_cell2;
	count = sizeof(reifen_display_cell2)/sizeof(DISPLAY_CELL);
	for(i=0;i<count;i++)
	{
		if(pCell[i].nID==tire) return &pCell[i];
	}
	return NULL;
}

void reifen_callback(unsigned char* buf,HWND hWnd)
{
	DWORD dw;
	BYTE isAlarm=0;

	if(buf==NULL)
	{
		if(g_hWnd!=NULL && IsWindow(g_hWnd))
		{
			InvalidateRect(g_hWnd,NULL,TRUE);
			UpdateWindow(g_hWnd);
		}
		return;
	}
	if(1 ==buf[0])
	{
		isAlarm = buf[1];
		if(isAlarm==4){
			send_tire_cfg();
		}else{
			int tire = buf[2];
			DISPLAY_CELL* cell = find_tire( tire)	;
			if(cell)
			{
				if(ByteInvalid(buf[3]) || ShortInvalid((&buf[4])) ){
					sprintf(cell->pstr,"--- \n--- ") ;
					cell->color = TUHUANG_CLR;

				}else{
					cell->press = (buf[3]&0xff)*4./100;
					DWORD dw= BY2HW(dw, &buf[4]);
					cell->temp = (dw)*0.03125-273.;
				
					
					sprintf(cell->pstr,"%.1f \n%.0f " ,cell->press,cell->temp) ;
					cell->color = get_color( cell->press , cell->temp,cell->nID);
				}
			}
			if(isAlarm==3)
			{
				PostMessage(hWnd,WM_USER_INDICATE ,0,2);
			}
		}
 
	} 
	if(g_hWnd!=NULL && IsWindow(g_hWnd))
	{
		//InvalidateRect(g_hWnd,NULL,TRUE);
		//UpdateWindow(g_hWnd);
	}
}

static void AlertWndMessage(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	//Draw.SetDrawFontSize( LongTitleFontHeight+4, LongTitleFontWide+2,FW_BOLD,__FONT_NORMAL__);
	if(pExtra==0){
		Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(msg,CRect(140,120,668,394),DT_LEFT/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );
	}else{
		Draw.SetDrawFontSize(TitleFontHeight,TitleFontWide,FW_BOLD,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(pExtra,CRect(240,120,568,394),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );

		Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(msg,CRect(160,200,648,394),DT_LEFT/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );
	}
}
static void AlertWndMessage2(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	//Draw.SetDrawFontSize( LongTitleFontHeight+4, LongTitleFontWide+2,FW_BOLD,__FONT_NORMAL__);
	if(pExtra==0){
		Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(msg,CRect(160,180,668,374),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );
	}else{
		Draw.SetDrawFontSize(TitleFontHeight,TitleFontWide,FW_BOLD,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(pExtra,CRect(240,120,568,394),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );

		Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(msg,CRect(160,200,648,394),DT_LEFT/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );
	}
} 
int AlertBox(int  msgId, int style,int extraId)
{
	CString	strTitle;
	strTitle.LoadString(msgId);
   const BUTTON_ITEM Button_Cancel[] = 
   {
	{ 592, 302,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},{ 0, 0,	0, 0,0    ,0     ,0}

   };
   const BUTTON_ITEMEX Button_Confirm[3]= {
				{ 180, 280,	201, 75,IDOK      ,IDBI_BUTTON_121x43,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL ,IDS_YES},
				{ 420, 280,	201, 75,IDCANCEL   ,IDBI_BUTTON_121x43,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_NO},
				{ 0, 0,	0, 0,0    ,0     ,0}};

	CpssMsgDlg dlg1(IDB_BK_POP_DETAIL,strTitle,0);	
	dlg1.m_BmpButtonTmpl = (style==0)?Button_Cancel:NULL;
	dlg1.m_TxtButtonTmpl = (style==0)?NULL:Button_Confirm;
	dlg1.fnDrawMessage = (style<2)?AlertWndMessage:AlertWndMessage2;
	dlg1.m_bSound=1;
	if(extraId!=0){
		strTitle.LoadString(extraId);
		dlg1.SetExtraText((LPTSTR)(LPCTSTR)strTitle);
	}
	return dlg1.DoModal();
}
LRESULT ReifenDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 t55_get_reifen();
	
	m_btnlist[0].CreateWndTrans(m_hWnd,m_nIDBACK,xxButtonInfo.rt, xxButtonInfo.uId, xxButtonInfo.bmpId, xxButtonInfo.bmpId_dn);
	//CREATE_BTN_TRANS2(m_btnlist[i], m_nIDBACK, Button_EngInfo[i]);
	 
	CString str;
	RECT rect;
	rect = Button1_EngInfo[0].rt;
		
	g_hWnd= m_hWnd;
	if(g_dwConfigable){
		for(int i=0; i<sizeof(Button1_EngInfo)/sizeof(BUTTON_ITEMEX) ; i++)
		{
			str.LoadString(Button1_EngInfo[i].uId );
			CREATE_BTN_TRANS(m_btAct[i], m_nIDBACK,str,Button1_EngInfo[i]);
			
		}
	}

	 
	//str.LoadString(Button2_Info[0].uId );
	//CREATE_BTN_TRANS(m_btAct[1], m_nIDBACK,str,Button2_Info[0]);
		
	 

	m_btn2Func.CreateWndTrans(m_hWnd,m_nIDBACK,Button_LR[0].rt,IDD_BUTTONS_RIGHT,
								  IDBI_LEFTRIGHT_RIGHT,
								  IDBI_LEFTRIGHT_RIGHT_DN);	

	//DWORD dwID;
	//ghExitEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	//g_hCommandThread = CreateThread(NULL,0 , CommandTask ,(void*)m_hWnd,0, &dwID);


	//OnButton2(0,0,0, bHandled);
	
	m_nTimer = SetTimer(1,30000,NULL);
	VButtonWnd::OnInitDialog(uMsg, wParam, lParam, bHandled) ;
    return 0;  
}

#define CELL_H 62
#define CELL_W 140
void ReifenDlg::OnPaintExt(HDC hDC,CRect& rcPaint)
{
	DrawDC Draw(hDC);
	CCanvas canvas(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(255,255,255));
	CRect rect;
	HFONT hOldFont = Draw.SetFont(m_hBigFont);
	CString str;
	
DISPLAY_CELL * pCell=0;
	int count;
	if(m_nIndex==0) 
	{
		pCell = reifen_display_cell;
		count = sizeof(reifen_display_cell)/sizeof(DISPLAY_CELL);
	}else
	{
		pCell = reifen_display_cell2;
		count = sizeof(reifen_display_cell2)/sizeof(DISPLAY_CELL);
	}
	int i,j;
	TCHAR wText[16];
	UINT bold = 32;
	for(i=0;i<count;i++)
	{
		rect.left = pCell[i].pt.x;rect.top = pCell[i].pt.y;
		rect.right = rect.left+ CELL_W;rect.bottom = rect.top+ CELL_H;
		if(pCell[i].color==0) pCell[i].color = TUHUANG_CLR ;

		//Draw.DrawNewRect2(&rect,TRUE,TRUE,pCell[i].color);
		int t = color2id(pCell[i].color);
		draw_placeholder(pCell[i].placehold[t],reifenBmpId[t]);
		/*
		if(pCell[i].placehold[t].m_hBitmap==NULL)
		{
			pCell[i].placehold[t].LoadBitmap(reifenBmpId[t],m_nIDBACK,rect.left,rect.top);
		}
		canvas.BitBlt(pCell[i].placehold[t],rect.left,rect.top,TRUE);*/
		if( strlen(pCell[i].pstr)<2)
		{
			wcscpy(wText,L"---");
			Draw.DrawStringRect(wText,&rect,DT_CENTER|DT_VCENTER);
		}else {
			char* p = strchr(pCell[i].pstr,'\n');
			if(p)
			{
				char sz[16];
				int len =  p-pCell[i].pstr;
				strncpy( sz, pCell[i].pstr,len);
				sz[len]=0;
				p++;
				rect.bottom-= rect.Height()/2;rect.top+=2;
				Draw.DrawStringRect(convert_val(sz,PRESS_UNIT),&rect,DT_CENTER|DT_VCENTER);
				rect.OffsetRect(0,rect.Height()-2);
				Draw.DrawStringRect(convert_val(p,TEMP_UNIT),&rect,DT_CENTER|DT_VCENTER);
			} 
		}
		
	}
 
	Draw.SetFont(hOldFont);
	 
}
 

LRESULT ReifenDlg::OnCfg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	AlertBox(IDS_REIFEN_CFG_MSG);
	TireCfg dlg;
	dlg.DoModal();
	send_tire_cfg();
	Invalidate();UpdateWindow();
  return 0;
}


LRESULT ReifenDlg::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	//SetEvent(ghExitEvent);
	//if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
	__restore_pre_window_handle__(m_hWnd);
	g_hWnd= NULL;
	if(m_nTimer) KillTimer(m_nTimer); m_nTimer =0;
	//CloseHandle(ghExitEvent);
	EndDialog(1);
	//PostQuitMessage(0);
	
	return 0;
}



LRESULT ReifenDlg::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	t55_get_reifen();
	
	return 0;
}


LRESULT ReifenDlg::OnUserIndicate(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
 

	return 0;
} 

 void ReifenDlg::UpdatePage(int page)
{
	if(page==0)
		RL_BTN_FUNC(IDD_BUTTONS_RIGHT,IDD_BUTTONS_RIGHT);
	else if( page==PAGES-1)
		RL_BTN_FUNC(IDD_BUTTONS_LEFT,IDD_BUTTONS_LEFT);
	else RL_BTN_FUNC(IDD_BUTTONS_LEFT, IDD_BUTTONS_RIGHT);
	int id = IDB_Reifen_BK2;
	if(page==0){ id = IDB_Reifen_BK1; }
	else id = IDB_Reifen_BK2;
	m_DrawList->ReplaceBK(id );
	m_nIDBACK = id;
	Invalidate();
	UpdateWindow();
 	
}
 
LRESULT ReifenDlg::OnLeftRight(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(wID == IDD_BUTTONS_RIGHT) {
		if(m_nIndex<1) m_nIndex++;
	}
	else if(wID == IDD_BUTTONS_LEFT) 
	{	 
		if(m_nIndex>0) m_nIndex--;
	}
	bHandled = 1;
	UpdatePage(m_nIndex);
 
	return 1;
}


static int press2color(float tmp ,TIRE_CFG* cfg)
{

	//TIRE_CFG* cfg = find_cfg(tire);
	if(cfg)
	{
		float p1  = cfg->pressure[0];
		float p2  = cfg->pressure[1]-cfg->pressure[3];
		float p3  = cfg->pressure[1]+cfg->pressure[3];
		float p4  = cfg->pressure[2];
		if( (tmp>= p2 ) && (tmp<= p3) ) 
			return GREEN_CLR;
		else if( tmp < p1 || tmp> p4 ) return RED_CLR;
		else return TUHUANG_CLR;/* if( tmp <p2 ){
			int w = p2 - p1;
			return RGB( 255*(p2-tmp )/w , 255*( tmp-p1 )/w,0);
		}else 
		{
			int w = p4 - p3;
			return RGB( 255*(tmp-p3 )/w , 255*( p4-tmp )/w,0);
		} */
	}
	
	return 0x999999;
}
static int temp2color(float tmp, TIRE_CFG* cfg)
{
	
//TIRE_CFG* cfg = find_cfg(tire);
	if(cfg)
	{
		float p1  = cfg->temp[1]+cfg->temp[3];
		float p2  =  cfg->temp[2];
		 
		if(   tmp<= p1 ) 
			return GREEN_CLR;
		else if(  tmp>= p2 ) return RED_CLR;
		else
		{
			/*int w = p2 - p1;
			return RGB( 255*(tmp-p1 )/w , 255*( p2-tmp )/w,0);*/
			 return TUHUANG_CLR;
		}
	}	
	return 0x999999;
}

int get_color(float press , float tmp, int tire)
{
TIRE_CFG* cfg = find_cfg(tire);
	if(cfg)
	{
		COLORREF clr1 = press2color(press ,cfg);
		COLORREF clr2 = temp2color( tmp,   cfg);
		/*BYTE r = max( GetRValue(clr1), GetRValue(clr2) );
		BYTE g = min( GetGValue(clr1), GetGValue(clr2) );
		return RGB(r,g,0);
		*/
		if(clr1==RED_CLR|| clr2==RED_CLR) return RED_CLR;
		else if(clr1==TUHUANG_CLR|| clr2==TUHUANG_CLR) return TUHUANG_CLR;
		else return  GREEN_CLR ;
	}
	
	return 0x999999;
}

int DoAktuelle( )
{
	int ret = AlertBox(IDS_Aktuelle_TEXT ,1, IDS_Aktuelle_TITLE);
	if(ret==IDOK)
	{
		int i=0;
		BOOL bSet = FALSE;
		while(gTireCfg[i].nID!=0){
			 DISPLAY_CELL* cell = find_tire( gTireCfg[i].nID)	;
			 if(cell && cell->pstr[0]!=0){
				gTireCfg[i].pressure[1] = cell->press;//Sollwert
				gTireCfg[i].temp[1] = cell->temp;//Sollwert

				float tolerance = gTireCfg[i].pressure[3]*2;
				gTireCfg[i].pressure[0] = max(0.f, gTireCfg[i].pressure[1]-tolerance);
				gTireCfg[i].pressure[2] = gTireCfg[i].pressure[1]+tolerance;
				gTireCfg[i].temp[0] = max(0.f, gTireCfg[i].temp[1]-tolerance);
				gTireCfg[i].temp[2] = max(0.f, gTireCfg[i].temp[1]+tolerance);
				bSet= TRUE;
			 }
			i++;
		}
 
		if(bSet) send_tire_cfg();

	}else {
	}
	return 0;
}

void update_cfg()
{
	FILE* f = fopen( "\\DataOverIP\\IN\\tirecfg.cfg","rt");
		 
	if (f != NULL) 	
	{
		char buf[256];
		memset(buf,256,0);
		char* p= fgets(buf,255,f);
		while(p) 
		{
			int len = strlen(buf);
			if(buf[len-1]==0xa || buf[len-1]==0xd ){ buf[len-1]=0;len--;} 
			if(len<=0) break;
			int id=0;
			char ch=0;
			float flow, fdesired , fhigh, ftolence;
			int n = sscanf(buf,"%c.%x=%f,%f,%f,%f", &ch,&id,&flow, &fdesired , &fhigh, &ftolence);
			if(n>=6)
			{
				TIRE_CFG* cfg = find_cfg(id);
				if(cfg)
				{
					if(ch=='p'){
						cfg->pressure[0]=flow;cfg->pressure[1]=fdesired;cfg->pressure[2]=fhigh;cfg->pressure[3]=ftolence;
					}
					else if(ch=='t'){
						cfg->temp[0]=flow;cfg->temp[1]=fdesired;cfg->temp[2]=fhigh;cfg->temp[3]=ftolence;
					}
				}
			}
			p= fgets(buf,255,f);
		}
		fclose(f);
		DeleteFile(_T("\\DataOverIP\\IN\\tirecfg.cfg"));

		send_tire_cfg();
		//set to rainer

		if(g_hWnd!=NULL && IsWindow(g_hWnd))
		{
			InvalidateRect(g_hWnd,NULL,TRUE);
			UpdateWindow(g_hWnd);
		}
	}
}

LRESULT ReifenDlg::OnButtonHelp(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	CRect rt(260,Btn_Bottom, 0,0);
 ShowSimpleMsgBox(IDS_HLP_REIFEN,IDBI_HLP_REIFEN, rt,IDBI_HLP_REIFEN_BK);
	return 0;
}